"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _certVerifierJs = require("cert-verifier-js");

var _reactTimestamp = _interopRequireDefault(require("react-timestamp"));

var _reactJsonView = _interopRequireDefault(require("react-json-view"));

var _core = require("@material-ui/core");

var _icons = require("@material-ui/icons");

var _blockcertsLogo = _interopRequireDefault(require("../assets/images/blockcertsLogo"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var styles = function styles(theme) {
  return {
    root: {
      overflow: 'hidden',
      padding: theme.spacing(4),
      backgroundColor: '#02112a'
    },
    logo: {
      textAlign: 'center',
      marginBottom: theme.spacing(8)
    },
    stepperRoot: {
      paddingLeft: 0,
      paddingRight: 0,
      backgroundColor: '#02112a'
    },
    step: {
      color: '#ffffff !important'
    },
    text: {
      color: '#ffffff'
    },
    verificationResult: {
      color: '#ffffff',
      textAlign: 'center',
      marginBottom: theme.spacing(4)
    },
    verificationResultCaption: {
      color: '#ffffff',
      textAlign: 'justify',
      display: 'block',
      marginBottom: theme.spacing(4)
    },
    buttons: {
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'center',
      marginBottom: theme.spacing(4)
    },
    buttonOutlined: {
      borderColor: '#ffffff',
      '&:hover': {
        backgroundColor: 'rgba(255, 255, 255, 0.08)'
      },
      marginBottom: theme.spacing(4)
    },
    buttonIcon: {
      marginRight: theme.spacing(1)
    },
    dialogContentRoot: {
      textAlign: 'justify'
    },
    reactJson: {
      marginBottom: theme.spacing(1)
    }
  };
};

var Blockcerts =
/*#__PURE__*/
function (_Component) {
  _inherits(Blockcerts, _Component);

  function Blockcerts(props) {
    var _this;

    _classCallCheck(this, Blockcerts);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Blockcerts).call(this, props));
    _this.state = {
      src: null,
      error: null,
      certificate: null,
      verificationSteps: [],
      verificationStep: null,
      verificationResult: null,
      dialogOpen: false
    };
    return _this;
  }

  _createClass(Blockcerts, [{
    key: "handleDialog",
    value: function handleDialog() {
      var dialogOpen = this.state.dialogOpen;
      dialogOpen = !dialogOpen;
      this.setState({
        dialogOpen: dialogOpen
      });
    }
  }, {
    key: "handleVerifyCertificate",
    value: function handleVerifyCertificate() {
      var _this2 = this;

      var _this$state, certificate, verificationSteps, verificationResult;

      return regeneratorRuntime.async(function handleVerifyCertificate$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this$state = this.state, certificate = _this$state.certificate, verificationSteps = _this$state.verificationSteps;
              _context.prev = 1;
              _context.next = 4;
              return regeneratorRuntime.awrap(certificate.verify(function (_ref) {
                var code = _ref.code,
                    label = _ref.label,
                    status = _ref.status,
                    errorMessage = _ref.errorMessage;

                if (status !== 'starting') {
                  verificationSteps.push({
                    code: code,
                    label: label,
                    status: status,
                    errorMessage: errorMessage
                  });
                  var verificationStep = verificationSteps.length - 1;

                  _this2.setState({
                    verificationSteps: verificationSteps,
                    verificationStep: verificationStep
                  });
                }
              }));

            case 4:
              verificationResult = _context.sent;

              if (verificationResult.status === 'success') {
                this.setState({
                  verificationStep: 999
                });
              }

              this.setState({
                verificationResult: verificationResult
              });
              _context.next = 12;
              break;

            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](1);
              this.setState({
                error: _context.t0.message
              });

            case 12:
            case "end":
              return _context.stop();
          }
        }
      }, null, this, [[1, 9]]);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var src, response, certificate;
      return regeneratorRuntime.async(function componentDidMount$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              src = this.props.src;

              if (!(typeof src === 'string')) {
                _context2.next = 14;
                break;
              }

              _context2.prev = 2;
              _context2.next = 5;
              return regeneratorRuntime.awrap(window.fetch(src));

            case 5:
              response = _context2.sent;
              _context2.next = 8;
              return regeneratorRuntime.awrap(response.json());

            case 8:
              src = _context2.sent;
              _context2.next = 14;
              break;

            case 11:
              _context2.prev = 11;
              _context2.t0 = _context2["catch"](2);
              this.setState({
                error: _context2.t0.message
              });

            case 14:
              if (_typeof(src) === 'object') {
                try {
                  certificate = new _certVerifierJs.Certificate(src);
                  this.setState({
                    src: src,
                    certificate: certificate
                  });
                  this.handleVerifyCertificate();
                } catch (e) {
                  this.setState({
                    error: e.message
                  });
                }
              }

            case 15:
            case "end":
              return _context2.stop();
          }
        }
      }, null, this, [[2, 11]]);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var classes = this.props.classes;
      var _this$state2 = this.state,
          src = _this$state2.src,
          error = _this$state2.error,
          certificate = _this$state2.certificate,
          verificationSteps = _this$state2.verificationSteps,
          verificationStep = _this$state2.verificationStep,
          verificationResult = _this$state2.verificationResult,
          dialogOpen = _this$state2.dialogOpen;

      if (error) {
        return _react["default"].createElement(_core.Typography, {
          color: "error"
        }, error);
      }

      if (!src) {
        return _react["default"].createElement(_core.CircularProgress, null);
      }

      return _react["default"].createElement("div", {
        className: classes.root
      }, _react["default"].createElement(_core.Grid, {
        container: true,
        spacing: 4
      }, _react["default"].createElement(_core.Grid, {
        item: true,
        xs: 12,
        md: 9
      }, _react["default"].createElement(_core.Paper, null, src.displayHtml && _react["default"].createElement("div", {
        dangerouslySetInnerHTML: {
          __html: src.displayHtml.replace(/(<? *script)/gi, 'illegalscript')
        }
      }), !src.displayHtml && _react["default"].createElement("div", null, _react["default"].createElement("img", {
        src: certificate.certificateImage,
        className: classes.image
      }), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "h1"
      }, certificate.title), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "subheading"
      }, certificate.subtitle), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "caption"
      }, "Awarded on ", _react["default"].createElement(_reactTimestamp["default"], {
        time: src.issuedOn.toString(),
        format: "full"
      }), " to"), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "title"
      }, certificate.name), _react["default"].createElement(_core.Typography, {
        paragraph: true
      }, certificate.description), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "caption"
      }, "Issued by"), _react["default"].createElement("img", {
        src: certificate.sealImage,
        className: classes.image
      }), _react["default"].createElement(_core.Typography, {
        paragraph: true,
        variant: "title"
      }, certificate.issuer.name), _react["default"].createElement(_core.Typography, {
        paragraph: true
      }, certificate.issuer.description), _react["default"].createElement(_core.Typography, {
        paragraph: true
      }, certificate.issuer.email)))), _react["default"].createElement(_core.Grid, {
        item: true,
        xs: 12,
        md: 3
      }, _react["default"].createElement("div", {
        className: classes.logo
      }, _react["default"].createElement("a", {
        href: "https://www.blockcerts.org/about.html",
        target: "_blank",
        rel: "noopener noreferrer",
        color: "inherit"
      }, _react["default"].createElement("img", {
        src: _blockcertsLogo["default"]
      }))), verificationResult ? verificationResult.status === 'success' ? _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_core.Typography, {
        variant: "h4",
        classes: {
          root: classes.verificationResult
        }
      }, "Valid ", _react["default"].createElement(_icons.CheckCircle, null)), _react["default"].createElement(_core.Typography, {
        variant: "caption",
        gutterBottom: true,
        classes: {
          root: classes.verificationResultCaption
        }
      }, "Due to current Blockcerts standard technical limitations, to be certain that this certificate is not a fake, please search for the official's issuer's website and look for a page that declares the following exact string as its \"Blockcerts issuer profile\": ", certificate.issuer.id), _react["default"].createElement("div", {
        className: classes.buttons
      }, _react["default"].createElement(_core.Button, {
        href: certificate.transactionLink,
        target: "_blank",
        rel: "noopener noreferrer",
        color: "inherit",
        variant: "outlined",
        classes: {
          label: classes.text,
          outlined: classes.buttonOutlined
        }
      }, _react["default"].createElement(_icons.Link, {
        classes: {
          root: classes.buttonIcon
        }
      }), "Transaction"), _react["default"].createElement(_core.Button, {
        onClick: function onClick() {
          return _this3.handleDialog();
        },
        color: "inherit",
        variant: "outlined",
        classes: {
          label: classes.text,
          outlined: classes.buttonOutlined
        }
      }, _react["default"].createElement(_icons.Link, {
        classes: {
          root: classes.buttonIcon
        }
      }), "Explanation"), _react["default"].createElement(_core.Button, {
        href: "https://github.com/guix77/react-blockcerts",
        target: "_blank",
        rel: "noopener noreferrer",
        color: "inherit",
        variant: "outlined",
        classes: {
          label: classes.text,
          outlined: classes.buttonOutlined
        }
      }, _react["default"].createElement(_icons.Link, {
        classes: {
          root: classes.buttonIcon
        }
      }), "Source code"))) : _react["default"].createElement(_core.Typography, {
        variant: "h4",
        classes: {
          root: classes.verificationResult
        }
      }, "Invalid ", _react["default"].createElement(_icons.Warning, null)) : _react["default"].createElement(_core.Typography, {
        variant: "h4",
        classes: {
          root: classes.verificationResult
        }
      }, "Verifying ", _react["default"].createElement(_core.CircularProgress, {
        size: 22,
        classes: {
          root: classes.text
        }
      })), (!verificationResult || verificationResult.status !== 'success') && _react["default"].createElement(_core.Stepper, {
        activeStep: verificationStep,
        orientation: "vertical",
        classes: {
          root: classes.stepperRoot
        }
      }, verificationSteps.map(function (step, index) {
        return _react["default"].createElement(_core.Step, {
          key: index
        }, _react["default"].createElement(_core.StepLabel, {
          error: step.status === 'failure',
          classes: {
            label: classes.step
          },
          StepIconProps: {
            classes: {
              root: classes.step
            }
          }
        }, step.label));
      })))), verificationResult && verificationResult.status === 'success' && _react["default"].createElement(_core.Dialog, {
        open: dialogOpen,
        onClose: function onClose() {
          return _this3.handleDialog();
        },
        fullWidth: true,
        maxWidth: "md"
      }, _react["default"].createElement(_core.DialogContent, {
        classes: {
          root: classes.dialogContentRoot
        }
      }, _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true
      }, "This certificate"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true
      }, "This certificate can either be on your device, attached in an email or hosted online. The place where it is does not matter : if this certificate is valid, it will be valid anywhere. And if someone tries to create a modified version, the fake content will be displayed, but the verification process will fail."), _react["default"].createElement(_core.Typography, {
        gutterBottom: true
      }, "Here you can explore this certificate data if you want:"), _react["default"].createElement("div", {
        className: classes.reactJson
      }, _react["default"].createElement(_reactJsonView["default"], {
        src: src,
        collapsed: true
      })), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true
      }, "The identity problem on the blockchain"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true
      }, "A university, that we call \"Issuer\", could just have an account on the blockchain, and add certificates. The problem is that blockchain accounts are anonymous. We can only know that a certain address 0xabcd... did something on the blockchain, but not know who it is. That's why all Issuers must declare their official blockchain address on their official website. This is what we call the \"Issuer profile\"."), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true
      }, "The data problem on the blockchain"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true
      }, "So now that the identity problem is solved, let's just add the certificate on the blockchain, right? Well, it's not that simple. Writing data on blockchain is extremely expensive, and on the Bitcoin blockchain, not even possible for complex data such as certificates. So instead of storing all the certificate data on the blockchain, we just store what we call their \"hash\" in computer science."), _react["default"].createElement(_core.Typography, {
        gutterBottom: true
      }, "See the fridge in your kitchen? Instead of certifying all the infinite complex arrangement of atoms it is made of, we just certify its serial number."), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true
      }, "Mass issuance of certificates"), _react["default"].createElement(_core.Typography, {
        gutterBottom: true
      }, "All right, we solved the data problem too, let's store a certificate hash on the blockchain! Well... we could. But what if want to issue a degree to 1000 students? Instead of repeating the process for each student, we would like to issue all those certificates at the same time. To do this, we use a cryptography concept called \"Merle tree\"."), _react["default"].createElement(_core.Typography, {
        gutterBottom: true
      }, "Picture yourself an oak tree. Instead of certifying each leaf, we can just certify the root of the oak tree. We can later proove that a given leaf belongs to this exact tree, and therefore that this leaf is certified."), _react["default"].createElement(_core.Typography, {
        variant: "h5",
        gutterBottom: true
      }, "To know more"), _react["default"].createElement(_core.Typography, null, "To know more, you can check the official Blockcerts site, forums and GitHub repositories.")), _react["default"].createElement(_core.DialogActions, null, _react["default"].createElement(_core.Button, {
        onClick: function onClick() {
          return _this3.handleDialog();
        }
      }, "Close"))));
    }
  }]);

  return Blockcerts;
}(_react.Component);

Blockcerts.propTypes = {
  src: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]).isRequired
};

var _default = (0, _core.withStyles)(styles)(Blockcerts);

exports["default"] = _default;